/***************************************************************************
                          kcam.cpp  -  description
                             -------------------
    begin                : Tue Dec  29 12:31:38 GMT 2003
    copyright            : (C) 2002 by bj@altern.org
    email                : bj@altern.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "kcam.h"

#include <qlabel.h>
#include <qxembed.h> 

#include <kmainwindow.h>
#include <kapplication.h>
#include <klocale.h>


#if 0
#include <X11/X.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/keysym.h>
#include <X11/Xatom.h>
#include <X11/Xutil.h>
#include <X11/extensions/XShm.h>
#endif

kcam::kcam()
    : KMainWindow( 0, "kcam" )
{
args = KCmdLineArgs::parsedArgs();
 if (args->count()>0) remoteUrl=args->url(0);
    // set the shell's ui resource file
//setXMLFile("kcamui.rc");
cWidget =new camWidget(this);
KStdAction::configureNotifications(this, SLOT(showNotifyDialog()), actionCollection());
KStdAction::quit(this, SLOT(slotQuit()), actionCollection());
if (!remoteUrl.isEmpty())
cWidget->camUrl->setText(remoteUrl.url());
resizeEvent=true;
width   = 320;
height  = 240;
speed=0;
lastTime=QTime::currentTime();
refreshTimer=10;
analyseMode=false;
;

QObject::connect (cWidget->kPushButton1,SIGNAL(clicked()),this,SLOT(slotPause()));
QObject::connect (cWidget->kPushButton2,SIGNAL(clicked()),this,SLOT(slotLive()));
QObject::connect (cWidget->checkMotion,SIGNAL(toggled(bool)),this,SLOT(slotAnalyse(bool)));
QObject::connect (cWidget->comboBox1,SIGNAL(activated(const QString&)),this,SLOT(slotChangeRefresh(const QString&)));
QObject::connect (cWidget->camUrl,SIGNAL(returnPressed(const QString&)),this,SLOT(slotChangeUrl(const QString&)));

cWidget->comboBox1->setCurrentText(i18n("10 seconds"));

paintWidget=new QPainter(cWidget->videoWidget); 
setCentralWidget(cWidget);

timer = new QTimer( this );
connect( timer, SIGNAL(timeout()),this, SLOT(updateView()) );

  KTempFile *tmpFile=new KTempFile(QString::null,".jpg");
  tempOpenFile=tmpFile->name();
  
  
cout<<"2"<<endl;  
  if (!remoteUrl.isEmpty())
  {
  m_job=KIO::file_copy( remoteUrl, KURL(tempOpenFile), -1, true,false,false);
  connect( m_job, SIGNAL( result( KIO::Job * ) ), this, SLOT( slotJobFinished ( KIO::Job * ) ) );
  }
  
  createGUI("kcamui.rc");
}

void kcam::slotQuit()
{
exit(1);
}

void kcam::showNotifyDialog()
{
KNotifyDialog::configure(this);
}

void kcam::slotChangeUrl(const QString& url)
{
cout<<"Changing URL "<<endl;
remoteUrl=url;
resizeEvent=true;
if (paintWidget->isActive()) paintWidget->end();
//if (m_job) m_job->kill();
disconnect(m_job,0,0,0);
KIO::NetAccess::removeTempFile(tempOpenFile);
m_job=KIO::file_copy( remoteUrl, KURL(tempOpenFile), -1, true,false,false);
connect( m_job, SIGNAL( result( KIO::Job * ) ), this, SLOT( slotJobFinished ( KIO::Job * ) ) );
pauseMode=false;
}

void kcam::slotChangeRefresh(const QString& refreshTime)
{
cout<<refreshTimer<<endl;
if (refreshTime==i18n("Fastest")) refreshTimer=0;
if (refreshTime==i18n("1 second")) refreshTimer=1;
if (refreshTime==i18n("10 seconds")) refreshTimer=10;
if (refreshTime==i18n("30 seconds")) refreshTimer=30;
if (refreshTime==i18n("5 minutes")) refreshTimer=300;
if (refreshTime==i18n("10 minutes")) refreshTimer=600;
if (!pauseMode) 
updateView();
}

void kcam::slotResize(int w,int h)
{
width=w;
height=h;
cout<<"resizing "<<w<<" : "<<h<<endl;
cWidget->videoWidget->setFixedSize(QSize(w+2,h+2));
setUpLayout ();
updateGeometry();
kapp->processEvents();
}

void kcam::slotPause()
{
if (pauseMode) return;

disconnect(m_job,0,0,0);
if (paintWidget->isActive()) paintWidget->end();
paintWidget->begin(cWidget->videoWidget);
paintWidget->drawPixmap(1,1,pixmap,0,0,width,height);
paintWidget->fillRect(1,1,width,25,QBrush(QColor(20,20,20),Qt::Dense2Pattern));
paintWidget->setPen(QPen(QColor(200,200,200)));
paintWidget->drawText(10,20,i18n("Pause"));
paintWidget->end();
pauseMode=true;
timer->stop();
}

void kcam::slotAnalyse(bool isOn)
{
if (isOn) 
{
analyseMode=true;
return;
}
cWidget->kProgress1->setValue(0);
analyseMode=false;
updateView();
}


void kcam::slotLive()
{
if (!pauseMode) return;

pauseMode=false;
updateView();

}


void kcam::updateView()
{
if (remoteUrl.isEmpty()) return;

m_job=KIO::file_copy( remoteUrl, KURL(tempOpenFile), -1, true,false,false);
connect( m_job, SIGNAL( result( KIO::Job * ) ), this, SLOT( slotJobFinished ( KIO::Job * ) ) );
}

void kcam::slotJobFinished ( KIO::Job *copyJob)
{
//cout<<"Frame Over"<<endl;
kapp->processEvents();
if (copyJob->error()!=0) 
{
cout<<"error accessing cam"<<endl;
//KIO::NetAccess::removeTempFile(tempOpenFile);

//if (m_job) m_job->kill();
disconnect(m_job,0,0,0);
KIO::NetAccess::removeTempFile(tempOpenFile);
m_job=KIO::file_copy( remoteUrl, KURL(tempOpenFile), -1, true,false,false);
if (!pauseMode) 
connect( m_job, SIGNAL( result( KIO::Job * ) ), this, SLOT( slotJobFinished ( KIO::Job * ) ) );
//updateView();
return;
}

if (analyseMode)
{
//oldPix=pixmap;
oldImage=pixmap.convertToImage();
}

if (pixmap.load(tempOpenFile,"JPEG"))              // load and draw image
{
if (resizeEvent) 
{
pixmap=QPixmap(tempOpenFile);
slotResize(pixmap.width(),pixmap.height());
resizeEvent=false;
}

if (analyseMode)
{
currentImage=pixmap.convertToImage();
//bitBlt(&oldPix,0,0,&pixmap,0,0,width,height,Qt::AndNotROP);//XorROP);
//thirdImage=oldPix.convertToImage();
if (motionDetect())
{
KNotifyClient::event(0, "motion-detected", i18n("Motion detected"));
motionTimer.start( 1000*3, TRUE );
//pauseMode=true;
//return;
}
/*


picDiff=0;
QPixmap newpix=pixmap;
bitBlt(&newpix,1,1,&oldPix,0,0,width,height,Qt::XorROP);
QImage lastPixmap=newpix.convertToImage();
QSize size=lastPixmap.size();
long int picSize=size.width()*size.height();
long int i=1;
long int j=1;
int maxDiff=36;
int precision=5;
//QRgb picRgb;
QColor picColor;
while (i<size.height())
{
while (j<size.width())
{
picColor.setRgb(lastPixmap.pixel(j,i));
picDiff+=(picColor.red()+picColor.blue()+picColor.green())/3;
//if (picDiff>maxDiff) maxDiff=picDiff;
j+=precision;
}
i+=precision;
j=1;
}
picDiff=picDiff/(picSize/(precision*precision));
if ((picDiff>maxDiff) && (motionTimer.timerId ()==-1))  ////////////// motion detected
{
//bitBlt(cWidget->videoWidget,1,1,&newpix,0,0,width,height);
KNotifyClient::event(0, "motion-detected", i18n("Motion detected"));
motionTimer.start( 1000*3, TRUE );
//pauseMode=true;
//return;
}
cout<<"Motion Detected at: "<<QTime::currentTime().hour()<<":"<<QTime::currentTime().minute()<<":"<<QTime::currentTime().second()<<" / "<<picDiff<<endl;
*/
}

if (paintWidget->isActive()) paintWidget->end();
paintWidget->begin(cWidget->videoWidget);
paintWidget->drawPixmap(1,1,pixmap,0,0,width,height);


//paintWidget->end();
	//paintWidget->flush();
speed++;
}
  //KIO::NetAccess::removeTempFile(tempOpenFile);
if (!pauseMode) 
{
if (refreshTimer!=0) timer->start( 1000*refreshTimer, TRUE );
else updateView();
}
}

bool kcam::motionDetect()
{
//cout<<"Motion detect"<<endl;
/// some code borrowed from Gspy (http://gspy.sourceforge.net/)
//if (thirdImage.isNull()) return false;
QColor picColor;
QColor oldColor,currentColor;
int red,green,blue,cresult;
float fresult=0;
int pas=3;
	
	for (int y=0; y<height; y+=pas)
	{
		for (int x=0; x<width; x+=pas)
		{
		
			// give the cpu something to do...
			// compute rms diff between all pixels
			// detection of color or intensity changes detected
			
			oldColor.setRgb(oldImage.pixel(x,y));
			currentColor.setRgb(currentImage.pixel(x,y));

			red = abs(oldColor.red()-currentColor.red());	// red
			green = abs(oldColor.green()-currentColor.green());
			blue = abs(oldColor.blue()-currentColor.blue());
			
			//picColor.setRgb(thirdImage.pixel(x,y));
			//cresult=sqrt((picColor.red()*picColor.red()+picColor.blue()*picColor.blue()+picColor.green()*picColor.green())/3);


			cresult = sqrt((red*red + green*green + blue*blue)/3);
			fresult += (double) cresult;
		}
	}
	// calculate normalized difference over picture
	fresult = fresult/(float)(width*height/pas/pas);
	cWidget->kProgress1->setValue((int)fresult);
	cout<<"DIFF: "<<fresult<<endl;
	if (fresult>6) return true;
	return false;
	
	
	/*
	// detect and mark pixels that are significantly different
	threshold = (guchar)sig_pix_threshold;
	pixcnt = 0;
psrc  = &res_buf[0];
	while ( psrc < res_buf+sizeof(res_buf))
	{
		if ( *psrc > threshold )
		{
			pixcnt++;
			*psrc = 255;		// alarm active areas in white
			*(psrc+1) = 255;
			*(psrc+2) = 255;
		}
			
		psrc += 3;			// only need to look at reds of each pixel
							// because g and b are set to the same thing			
	}
	
	// to eliminate small changes (wind blown objects) from causing so much
	// havoc, we will try to eliminate false alarms by scanning for blobs	
	// A blob is a 3x3 pixel area, all must be 'hot' (white)
	blob_cnt = 0;
	psrc  = res_buf + 320 * 3;
	while ( psrc < (res_buf+sizeof(res_buf)-320*3))
	{
		for (i=0;i<1;i++)
		{
			if (*psrc < 255) break;			// central pixel must be lite
			if (*(psrc-320*3) < 255) break;	// pixel above must be lite
			if (*(psrc+320*3) < 255) break;	// pixel below must be lite
			if (*(psrc-3) < 255) break;		// pixel to left must be lite
			if (*(psrc+3) < 255) break;		// pixel to right must be light
			if (*(psrc-320*3+3) < 255) break;		// pixel to  NE must be light			
			if (*(psrc-320*3-3) < 255) break;		// pixel to  NW must be light						
			if (*(psrc+320*3+3) < 255) break;		// pixel to  SE must be light						
			if (*(psrc+320*3-3) < 255) break;		// pixel to  SW must be light						
			// mark blob as blob on screen
			*(psrc+2) = 0;	// shut off blue
			*(psrc+1) = 0;  // shut off green
			blob_cnt++;
			x = ((psrc - res_buf) % (320 * 3))/3;
			y = (psrc - res_buf) / (320 * 3);
			if ( x < alarm_zone.x1 )		// set first occurance location
				alarm_zone.x1 = x;
			if ( alarm_zone.x2 < x )		// keep highest occurance
				alarm_zone.x2 = x;			
			if ( y < alarm_zone.y1 )		// set first occurance location
				alarm_zone.y1 = y;
			if ( alarm_zone.y2 < y )		// keep highest occurance
				alarm_zone.y2 = y;			
		}
		psrc += 3;
	}
*/
}

kcam::~kcam()
{
if (paintWidget->isActive()) paintWidget->end();
}
//////////  recording: jpeg2yuv -I p -f 25 -j /tmp/kde-kith/kcamWQuWmb.jpg > test2.yuv

#include "kcam.moc"
