/***************************************************************************
                          kcam.h  -  description
                             -------------------
    begin                : Tue Dec  29 12:31:38 GMT 2003
    copyright            : (C) 2002 by bj@altern.org
    email                : bj@altern.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#ifndef _KCAM_H_
#define _KCAM_H_

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif


#include <kmainwindow.h>
#include <kpushbutton.h>
#include <ktempfile.h>
#include <klineedit.h>
#include <kio/netaccess.h>
#include <kio/job.h>
#include <kio/jobclasses.h>
#include <kaction.h>
#include <knotifydialog.h>
#include <kcmdlineargs.h>


#include "knotifyclient.h"

#if 0
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/extensions/shape.h>
#include <Imlib.h>
#endif
#include <qapplication.h>
#include <qgroupbox.h>
#include <qlayout.h> 
#include <qstring.h> 
#include <qeventloop.h> 
#include <qcombobox.h> 
#include <kprogress.h> 
#include <qtimer.h> 
#include <qdatetime.h> 
#include <qpainter.h> 
#include <qpixmap.h> 
#include <qimage.h> 
#include <qcheckbox.h> 
#include <qsize.h> 

#include "kcamwidget.h"

#define DEFAULT_WIDTH 320
#define DEFAULT_HEIGHT 240

class kcam : public KMainWindow
{
    Q_OBJECT
public:
    /**
     * Default Constructor
     */
    kcam();

KURL remoteUrl;
bool pauseMode, resizeEvent,analyseMode;
int refreshTimer,speed,width,height;
QTime lastTime;
QTimer *timer,motionTimer;
int picDiff;
camWidget *cWidget;
QPainter *paintWidget;
QPixmap pixmap, oldPix;
QImage oldImage,currentImage,thirdImage;
QString tempOpenFile;
KIO::FileCopyJob *m_job;
    /**
     * Default Destructor
     */
    virtual ~kcam();

protected:
        KCmdLineArgs *args;
    
public slots:
    void slotChangeUrl(const QString& url);
    void slotChangeRefresh(const QString&);
    void updateView();
    void slotResize(int w,int h);
    void slotPause();
    void slotLive();
    void slotAnalyse(bool isOn);
    void slotJobFinished ( KIO::Job *copyJob);
    void showNotifyDialog();
    void slotQuit();
    bool motionDetect();
};

#endif // _KCAM_H_
